throw(false) does not work as expected
Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.4.0dev (2016-09-09 trunk 56124)

[x86_64-linux]

Backport: 2.1: UNKNOWN, 2.2: DONE, 2.3: DONE

Description

I expect UncaughtThrowError for these examples:

$ ruby -e'throw false'

-e: unexpected throw

$ ruby -e'Fiber.new{throw false}.resume'

$ ruby -e'Thread.new{throw false}.join'

-e:1: [BUG] thread_join: THROW_DATA should not reach here.

ruby 2.4.0dev (2016-09-09 trunk 56124) [x86_64-linux]

-- Control frame information -----------------------------------------------

<snip>

 The cause is that Kernel#throw incorrectly finds a tag that is not created by Kernel#catch, because TH_PUSH_TAG() initializes

rb_vm_tag::tag with 0.

The attached patch seems to fix the issue, by making TH_PUSH_TAG() initialize with Qundef that should never appear in Ruby

code.

Associated revisions

Revision ed5a926b1320983e6802d17d6bc7c2d6c3f52989 - 09/26/2016 06:43 AM - rhenium (Kazuki Yamaguchi)

eval_intern.h: make TH_PUSH_TAG() initialize rb_vm_tag::tag with Qundef

eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

searches a tag with rb_vm_tag::tag == obj, throw(false) can

accidentally find an unrelated tag which is not created by

Kernel#catch.  [ruby-core:77229] [Bug #12743]

test/ruby/test_exception.rb (test_throw_false): Add a test case for

this.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56252 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ed5a926b - 09/26/2016 06:43 AM - rhenium (Kazuki Yamaguchi)

eval_intern.h: make TH_PUSH_TAG() initialize rb_vm_tag::tag with Qundef

eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

searches a tag with rb_vm_tag::tag == obj, throw(false) can

accidentally find an unrelated tag which is not created by

Kernel#catch.  [ruby-core:77229] [Bug #12743]

test/ruby/test_exception.rb (test_throw_false): Add a test case for

this.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56252 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 91a32fc030d6b74d5b43cabe48f29ebf1eec3331 - 09/26/2016 07:33 AM - nobu (Nobuyoshi Nakada)

test_exception.rb: another assertion
test/ruby/test_exception.rb (test_throw_false): test the thrown

tag.  [Bug #12743]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56254 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 91a32fc0 - 09/26/2016 07:33 AM - nobu (Nobuyoshi Nakada)

test_exception.rb: another assertion

test/ruby/test_exception.rb (test_throw_false): test the thrown

tag.  [Bug #12743]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56254 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ded40392317c885439232de5f7da3519ebce4ee5 - 10/17/2016 06:07 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 56252,56254: [Backport #12743]

    * eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

      Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

      searches a tag with rb_vm_tag::tag == obj, throw(false) can

      accidentally find an unrelated tag which is not created by

      Kernel#catch.  [ruby-core:77229] [Bug #12743]

    * test/ruby/test_exception.rb (test_throw_false): Add a test case for

      this.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56441 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ded40392 - 10/17/2016 06:07 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 56252,56254: [Backport #12743]

    * eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

      Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

      searches a tag with rb_vm_tag::tag == obj, throw(false) can

      accidentally find an unrelated tag which is not created by

      Kernel#catch.  [ruby-core:77229] [Bug #12743]

    * test/ruby/test_exception.rb (test_throw_false): Add a test case for

      this.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56441 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 04b031656add2a8c9f7f2136e4fc7fc16c9ac901 - 10/27/2016 07:48 AM - U.Nakamura 

merge revision(s) 56252,56254: [Backport #12743]

    * eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

      Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

      searches a tag with rb_vm_tag::tag == obj, throw(false) can

      accidentally find an unrelated tag which is not created by

      Kernel#catch.  [ruby-core:77229] [Bug #12743]

    * test/ruby/test_exception.rb (test_throw_false): Add a test case for

      this.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@56505 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 04b03165 - 10/27/2016 07:48 AM - U.Nakamura 

merge revision(s) 56252,56254: [Backport #12743]

    * eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

      Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

      searches a tag with rb_vm_tag::tag == obj, throw(false) can

      accidentally find an unrelated tag which is not created by

      Kernel#catch.  [ruby-core:77229] [Bug #12743]

    * test/ruby/test_exception.rb (test_throw_false): Add a test case for

      this.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@56505 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History
#1 - 09/26/2016 06:43 AM - Anonymous

- Status changed from Open to Closed

Applied in changeset r56252.

eval_intern.h: make TH_PUSH_TAG() initialize rb_vm_tag::tag with Qundef

eval_intern.h (TH_PUSH_TAG): Initialize struct rb_vm_tag::tag with

Qundef rather than 0 which is equal to Qfalse. Since Kernel#throw(obj)

searches a tag with rb_vm_tag::tag == obj, throw(false) can

accidentally find an unrelated tag which is not created by

Kernel#catch.  [ruby-core:77229] [Bug #12743]

test/ruby/test_exception.rb (test_throw_false): Add a test case for

this.

#2 - 09/26/2016 01:36 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED

#3 - 10/17/2016 06:07 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r56441 merged revision(s) 56252,56254.

#4 - 10/27/2016 07:48 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE to 2.1: UNKNOWN, 2.2: DONE, 2.3: DONE

ruby_2_2 r56505 merged revision(s) 56252,56254.

Files

0001-eval_intern.h-make-TH_PUSH_TAG-initialize-rb_vm_tag-.patch 1.53 KB 09/09/2016 rhenium (Kazuki Yamaguchi)
